# Changelog

## 28-06-2021 Version 2.27.5

- [ensure_*] Add guard for already defined class

## 31-05-2021 Version 2.27.4

- [core] Fixed loadpath for Puppet and added debug messages to puppet_service connections

## 31-05-2021 Version 2.27.3

- [core] Fixed loadpath for Puppet

## 31-05-2021 Version 2.27.2

- [core] Fix some more load paths

## 31-05-2021 Version 2.27.1

- [core] Made the load paths for some puppet functions more robust

## 25-05-2021 Version 2.27.0

- [resource_value] Allow specification of ensure value

## 17-05-2021 Version 2.26.2

- [valid_versions] Fix error when unkown version was specified

## 10-05-2021 Version 2.26.1

- [activate] Create a feature switch for using  activate_node_groups

## 05-05-2021 Version 2.26.0

- [secure] Add basic CIS and STIG implementation classes
- [generator] Move CIS/STIG generator to easy_type

## 09-04-2021 Version 2.25.0

- [yaml_data_without_warnings]  Add support for array values and automatic mapping of files

## 08-04-2021 Version 2.24.0

- [yaml_data_without_warnings] Initial implementation

## 02-04-2021 Version 2.23.1

- [entitlement/node_groups] Fix error handling and add debugging utils

## 30-03-2021 Version 2.23.0

- [license/node_groups] Add conveniance class to create base node_groups
- [node_group_entitlement] Add support for entilement management through node groups
- [encryption] Fix when calling encryption multiple times
- [em_data] Add support for catalog data

## 12-03-2021 Version 2.22.2

- [yaml_type] Fix on puppet versions without resource_api

## 08-03-2021 Version 2.22.1

- [generated_password] Remove the $ from the list of special character
- [get_puppet_file] Add the file name to an error generated by file not found
- [documentation] Update text regarding entitlements
- [core] Fix already initialized constant mesages on ruby 2.7+

## 12-02-2021 Version 2.22.0

- [numbered_entry] Allow bolt usage in combination with numbered licenses
- [yaml_type] Handle empty yaml file

## 05-02-2021 Version 2.21.0

- [daemon] Improve error handling in the daemon processes
- [emlicense] Add debug evaluation to ease debugging
- [profile/firewall] Add debug evaluation to ease debugging
- [profile/limits] Add debug evaluation to ease debugging
- [profile/packages] Add debug evaluation to ease debugging
- [profile/resources] Add debug evaluation to ease debugging
- [profile/sysctl] Add debug evaluation to ease debugging
- [profile/groups_and_users] Add debug evaluation to ease debugging
- [evaluate_puppet] Extract the function to evaluate puppet code

## 11-01-2021 Version 2.20.2

- [daemon] Fix ‘terminated with exception (report_on_exception is true)’ error
- [profile::groups_and_users] Change notice message to debug

## 11-01-2021 Version 2.20.1

- [profile::groups_and_users] Guard against missing passwords

## 05-01-2021 Version 2.20.0

- [daemon] Add support for kill at request

## 23-12-2020 Version 2.19.4

- [daemon] Fix undefined contant error
- [core] Remove warning ‘already initialized constants’

## 22-12-2020 Version 2.19.3

- [source_dir] Fix deprecation warning
- [yaml_type] Fix undefined method `is_a_boolean_kind? error on ensure property

## 21-12-2020 Version 2.19.2

[core] Fix ‘Use  Binding.source_location’ warnings on ruby 2.5 and higher

## 20-12-2020 Version 2.19.1

- [core] Remove left over ruby 1.8.7 construct
- [encrypted_yaml_property] Fix undefined method error

## 19-12-2020 Version 2.19.0

- [release] Add puppet 7 support to the metadata
- [core] Remove support for ruby 1.8

## 18-12-2020 Version 2.18.3

- [core] Also fix optional Booleans

## 17-12-2020 Version 2.18.2

- [core] Fix handling of boolean values

## 26-11-2020 Version 2.18.1

- [source_dir] Better handling of older Puppet versions

## 20-11-2020 Version 2.18.0

- [provider] Add to_hash method on provider

## 06-11-2020 Version 2.17.2

- [profile/firewall] Remove lookup of unused ports
- [profile/firewall] Hash from firewall define arguments replaced by lookups in firewalld and iptables defines.

## 22-10-2020 Version 2.17.1

- [release] Release error fixed

## 22-10-2020 Version 2.17.0

- [source_dir] Support later puppet http client for downloading files
- [versioned_data] Use regular load for yaml data instead of safe load on older versions
- [profile/resources] Generic resources defined type
- [functions/write_yaml] Bolt function to write data in yaml format into a file
- [tasks/extract_task] Initial version

## 14-10-2020 Version 2.16.2

- [functions/ordered_steps] Fix duplicate class error

## 14-10-2020 Version 2.16.1

- [functions/ordered_steps] Fix duplicate resource issue

## 10-10-2020 Version 2.16.0

- [ordered_steps] Make compatible with older puppet versions
- [profile] Initial implementation of defined types to use as implementation with ordered_steps
- [functions/debug_evaluation] Add function to aid in debugging
- [functions/staged_contain] deprecated function
- [functions/ordered_include] Add initial implementation
- [core] No dmi case in password generation added.

## 05-07-2020 Version 2.15.1

- [types] revert usage of Deferred data type for passwords

## 22-06-2020 Version 2.15.0

- [types] Allow the Easy_type::Password type to accept deferred values
- [source_dir] Handle systems with hardened  umask settings

## 22-06-2020 Version 2.14.1

- [entitlement] Fix when dmi fact does not exists

## 22-06-2020 Version 2.14.0

- [versioned_data] Versioned data hiera lookup Initial version

## 28-05-2020 Version 2.13.16

- [core] Fix JWT errors when used in conjunction with oci_config

## 18-05-2020 Version 2.13.15

- [extended_parameter] ignore ‘references an unresolved type’ errors when no type are available

## 18-05-2020 Version 2.13.14

- [extended_parameter] ignore ‘references an unresolved type’ errors
- [generated_password] Generate passwords accepted by Oracle

## 06-05-2020 Version 2.13.13

- [license] Fix error in copying entitlement files to agent nodes

## 14-04-2020 Version 2.13.12

- [licence] Fix duplicate resource issue when using numbered licenses

## 08-04-2020 Version 2.13.11

- [numbered_entry] Issue only a warning when the node is not in the list

## 07-04-2020 Version 2.13.10

- [entitlement] Work-arround for CentOS 8 not honouring the free license on VirtualBox

## 08-03-2020 Version 2.13.9

- [release] Make dependency on inifile less strict

## 08-03-2020 Version 2.13.8

[entitlement] Fix undefined method `virtual?' error

## 06-03-2020 Version 2.13.7

- [entitlements] Refacter checks on VirtualBox

## 06-03-2020 Version 2.13.6

- [em_license] Suppress warning on fact puppet_confdir
- [entitlements] Make sure default path is always in search list

## 25-02-2020 Version 2.13.5

- [core] Cache node list to increase performance

## 23-01-2020 Version 2.13.4

- [core] Fix array data type handeling
- [numbered_entry] Fix the message when the puppetserver is in the host file

## 20-01-2020 Version 2.13.3

- [numbered_entry] Change check on reverse lookup to non-hostfile lookup

## 17-01-2020 Version 2.13.2

- [provider] Don’t execute apply actions for destroy operations

## 13-01-2020 Version 2.13.1

- [provider] Fix errr when destroying resources

## 12-01-2020 Version 2.13.0

- [release] Update metadata to inlcude all supported OS-es
- [core] Add support for calling on_destroy on types and properties

## 27-11-2019 Version 2.12.7

- [extended_parameter] Fix array data type detection

## 26-11-2019 Version 2.12.6

- [extended_parameter] Fix handling of array data types

## 08-07-2019 Version 2.12.5

- [numbered_entry] Don’t fail all when more entries then specified
- [provider] Add support for bolt uploaded files
- [template] Add support for bolt uploaded files

## 08-07-2019 Version 2.12.4

- [entitlement] Don’t check for license when easy_type resource

## 23-06-2019 Version 2.12.3

- [validators] More consistent error messages

## 23-06-2019 Version 2.12.2

- [mungers] Fix size munger
- [source_dir] Change notice into debug message
- [yaml_type] Change notice message into debug message

## 21-06-2019 Version 2.12.1

- [types::size] Allow a regular Integer too

## 20-06-2019 Version 2.12.0

- [entitlement] Add support for warning levels
- [entitlements] Show more information
- [entitlements] Add support for multiple compile masters
- [docs] Fix help formatting

## 09-06-2019 Version 2.11.1

- [core] Fix shadowing the binding variable

## 09-06-2019 Version 2.11.0

- [provider] Add support to disable corrective change

## 07-06-2019 Version 2.10.7

- [numbered_entry] Better debug and error messages

## 06-06-2019 Version 2.10.6

- [emlicense] Better show license information
- [numbered_entry] always return empty array when values do not exist.

## 06-06-2019 Version 2.10.5

- [numbered_entry] Always use the specfied puppet master for lookup
- [docs] Fix documentation generation

## 31-05-2019 Version 2.10.4

- [numbered_entry] Better handling of reverse lookup puppetserver
- [validators] Better error messages for name validator

## 08-05-2019 Version 2.10.3

- [daemon] Better logging on timeout values and timeout configurable

## 08-05-2019 Version 2.10.2

- [resource_value] Better warning what the change in value is

## 07-05-2019 Version 2.10.1

- [core] Fix missing require

## 07-05-2019 Version 2.10.0

- [numbered_entry] Add deprecation warning for old url
- [numbered_entry] Tighten checks for puppet server
- [emlicense] Fix list function
- [em_entitlement] Use correct file name for registration
- [entitlements] Allow some modules to run without entitlements check
- [license::mount] Initial implementation
- [numbered_entry] More secure handling of user specified nodes
- [map_titles_to_attributes] Fix documentation
- [em_entitlement] Initial implementation
- [entitlement] Add real path to numbered entry
- [entilement] Add numbered entry yaml management

## 05-03-2019 Version 2.9.8

- [template] Add support for using templates in bolt

## 03-03-2019 Version 2.9.7

- [resource_value] Fix puppet 6 compatibility

## 02-03-2019 Version 2.9.6

- [core] reduce number of repeating debug messages
- [core] Fix validators when resource_api available
- [quality] Extend the versions to test
- [develop] Include pdk in Gemfile

## 02-03-2019 Version 2.9.5

- [core] Fix usage of resource_api
- [docs] Fix document generation

## 05-02-2019 Version 2.9.4

- [source_dir] Manage compressed tar files different

## 30-01-2019 Version 2.9.3

- [source_dir] Recognise tgz file as compressed tar
- [functions] Rename url_template to easy_type::url_template

## 28-12-2018 Version 2.9.2

- [core] Fix require ordering issue

## 28-12-2018 Version 2.9.1

- [release] Fix release error

## 28-12-2018 Version 2.9.0

- [core] Add support for resource_api

## 25-10-2018 Version 2.8.3

- [release] Fix error

## 25-10-2018 Version 2.8.2

- [release] Fix error

## 25-10-2018 Version 2.8.1

- [release] Fix error

## 25-10-2018 Version 2.8.0

- [daemon] refacter timed_read to fix timeout issues
- [generated_password] Initial implementation of hiera backed for password generation

## 20-09-2018 Version 2.7.0

- [types] Add password data type based on Sensitive

## 20-09-2018 Version 2.6.0

- [core] Add support for Puppet 6

## 31-07-2018 Version 2.5.0

- [staged_contain] Add support for conditional execution
- [types] Add unlimited to type Easy_type::Size
- [profile] Add common defined types for usage in profile modules
- [core] Fix mulitiline source code documentation

## 21-05-2018 Version 2.4.5

- [core] Fix missing hashes in documentation
- [doc_generator] Add better template for documentation generation in manifest
- [core] Documentation generation for Puppet source files
- [core] Validate location of entitlement in new versions
- [core] Add additional entitlement name checking

## 13-05-2018 Version 2.4.4

- [staged_contain] Fix nested staged_contains

## 13-05-2018 Version 2.4.3

- [staged_contain] Add unit tests and refactered the code

## 22-04-2018 Version 2.4.2

- [staged_contain] Changed implementation ti use variables instead of lookups
- [source_dir] Fix error when invalid value specified
- [core] Make puppet)reader  spec compatible with older ruby versions
- [core] Add puppet type parser
- [core] Fix docs rake task execution

## 22-04-2018 Version 2.4.1

- [core] Fix error ‘undefined method coerce’

## 26-03-2018 Version 2.4.0

- [core] Add basic support for data types
- [source_dir] Fix url checking

## 09-02-2018 Version 2.3.14

- [resource_task] First implementation
- [docs] Add generic docs
- [resource_value] Fix documentation
- [release] Fix readme text

## 25-01-2018 Version 2.3.13

- [release] remove comercial license text

## 25-01-2018 Version 2.3.12

- [release] Add license text and commercial license text

## 22-01-2018 Version 2.3.11

- [resource_value] Fix add_value and remove value properties

## 22-01-2018 Version 2.3.10

[resource_value] Add support for array values

## 17-01-2018 Version 2.3.9

- [staged_contain] Make a ruby implementation

## 17-01-2018 Version 2.3.8

Skipped

## 17-01-2018 Version 2.3.7

- [core] Add license notice to files
- [README] Updated for publishing on the forge
- [functions] Add initial implementation of staged_contain
- [numbered_entry] better warning when interpreting license for other puppetserver
- [entitlements] Better messages when no entitlements.yml is available

## 29-12-2017 Version 2.3.6

- [yaml_type] Use yaml.load again instead of safe_load
- [entitlements] Add support for purging expired license files

## 29-11-2017 Version 2.3.5

- [source_dir] Fix clean

## 22-11-2017 Version 2.3.4

- [entitlement] improve reporting of entitlement issues
- [entitlements] Make node names case insensitive

## 02-10-2017 Version 2.3.3

- [array_type] Fix ruby 2.3 and higher immutablility issue
- [daemon] Fix ruby 2.3 and higher immutablility issue

## 18-09-2017 Version 2.3.2

- [yaml_type] Fix symbol load problem. Closes #21
- [encryption] Fix Error: key must be 16 bytes on ruby 2.4 and higher
- [pay_per_use] Add debug informations
- [pay_per_use] Add simple validation flow
- [pay_per_use] Change way of validation

## 21-08-2017 Version 2.3.1

- [pay_per_use] Add node name data
- [pay_per_use] Add company name content
- [pay_per_use] Change time check
- [yaml_type] Only write yaml enabled properties
- [pay_per_use] Add servertime fixes

## 11-08-2017 Version 2.3.0

- [provider] Add support for selectively fetching properties
- [entitlements] Add support for pay-per-use

## 30-06-2017 Version 2.2.12

- [entitlements] Fix case with multiple DNS entries for a puppetserver

## 20-06-2017 Version 2.2.11

- [resource_value] Fix typo

## 20-06-2017 Version 2.2.10

- [data_types] Added data type Size
- [resource_value] Add unit tests
- [resource_value] Allow suppression of warnings
- [mungers] Add a boolean munger
- [entitlements] Better message when no entitlement available.
- [license::available] Purge old licenses

## 21-05-2017 Version 2.2.9

- [type] Add support for before_* and _ after actions on the type

## 19-05-2017 Version 2.2.8

- [bindings] Fix bindings

## 15-05-2017 Version 2.2.7

- [bindings] Add initial implementation
- [entilements] Show virtual entitlement for every module

## 05-05-2017 Version 2.2.6

- [core] Add array property to defaults
- [validators] Fix integer and port number validation
- [url_template] Fix access to variables

## 13-03-2017 Version 2.2.5

- [functions] Add url_template function
- [license] Add em_utils classes to easy_type

## 20-02-2017 Version 2.2.4

- [yaml_type] Fix when property contains a symbol value
- [validators] Make FQDN test more strict

## 27-01-2017 Version 2.2.3

- [docs] Fix docs tasks
- [provider] Fix append in combination with skip_without_properties
- [provider] Allow append options to on_… actions
- [source_dir] More specific verbose messages
- [yaml_type] Make ruby 1.9 compatible
- [provider] Add support for multiple providers in identity
- [resource_value] Add generated documentation
- [core] Create a tag for publishing

## 18-01-2017 Version 2.2.2

- [rake] Remove not used rake file
- [type] Better name for prefetch routine
- [entitlements] Added support for validators to all entitlements
- [type] Implemented the on_prefetch method
- [entitlements] Add support for passing the resources list to all validators
- [entitlements} Better readable warning when entitlement almost expired
- [entitlements] Add support for sized entitlements

## 02-01-2017 Version 2.2.1

- [core] Updated used versions
- [type] Better error message when using old map_title_to_attributes
- [resource_value] Start using map_titles_to_attributes

## 30-12-2016 Version 2.2.0

- [type] Add support for map_titles_to_attributes
- [core] Add support for dumping  resource content
- [property_value] Add initial implementation.

## 11-12-2016 Version 2.1.0

- [travis] Fix rake issue in test
- [core] Add support for parameterless on_apply and before_* and after_ methods

## 22-11-2016 Version 2.0.23

- [encryption] Extracted the encryption and decryption functionality
- [yaml_type] Add support for ensurable yaml types
- [yaml_type] Add shortcut to add and remove entries without calling puppet

## 20-11-2016 Version 2.0.22

- [yaml_type] Initial implementation

## 07-11-2016 Version 2.0.21

- [daemon] Show current output on timeout. This produces better errors on timeout

## 31-10-2016 Version 2.0.20

- [daemon] Add support for customizable error strings

## 27-10-2016 Version 2.0.19

- [entitlements] Add emlicense utility
- [entitlements] Fix fetching of  entitlements file

## 26-10-2016 Version 2.0.18

- [entitlement] Better mechanism for getting puppetserver name

## 26-10-2016 Version 2.0.17

- [entitlement] Add support for license ID

## 29-09-2016 Version 2.0.16

- [array_property] Remove change_to_s as module function

## 21-09-2016 Version 2.0.15

- [array_property] Make the change_to_s callable
- [source_dir] Better name for extract dir

## 19-09-2016 Version 2.0.14

- [source_dir] Add Initial implementation
- [rake] Add shared rake tasks for publishing and documentation
- [dcos] Add DocSimulator class for classes and defined types

## 26-08-2016 Version 2.0.13

- [helpers] Fix error in quoting

## 22-08-2016 Version 2.0.12

- [provider] Fix identity check when using subclasses for provides

## 21-08-2016 Version 2.0.11

- [helpers] Add support for downloading content through puppet:///.. urls

## 20-08-2016 Version 2.0.10

- [helpers] Better way of handling quoted values

## 18-08-2016 Version 2.0.9

- [entitlement] Changed licensing messages to debug
- [helpers] Add support for quoted fields in convert_csv_data_to_hash
- [template] reimplementation of local_template function
- [template] Better type directory detection

## 15-08-2016 Version 2.0.8

- [template] Add support for local template files.

## 13-08-2016 Version 2.0.7

- Make mechanism to find entitlemnts more robust
- [provider] Fix issue wich needs write access to module
- [entitlements] Add support for multiple numbered entitlements

## 12-07-2016 Version 2.0.6

- [entitlement] Fix error in VirtualBox entitlement

## 12-07-2016 Version 2.0.5

- [entitlement] Added support for numbered entitlement
- [core] Add geppetto  project file

## 07-07-2016 Version 2.0.4

- [spec] extended the tests to more Puppet versions
- [entitlements] Added support for wildcard node and domain specs.

## 04-07-2016 Version 2.0.3

- Add support for multiple concurrent entitlements

## 26-06-2016 Version 2.0.2

- Allow validators to be called as a function

## 17-05-2016 Version 2.0.1

- Add filter for  daemon

## 26-04-2016 Version 2.0.0

- Small fix in domain entitlement validator
- [docs] Added support for generating docs for new doc site
- [type] Remove deduction of module name. Now we must specify it
- [mungers] Allow support for absent values
- [doc]  Fix load path
- [provider] Fix problem when using command_builder
- [type] Move shared properties to module private directory
- [array_property] Fix change message when is or should is absent
- [syncers] Added case insensitive syncer
- [mungers] Added capitalize mungers
- [array_property] Fix check for string with comma
- Update to 1.06
- Small fix in domain entitlement validator
- Added support for encrypted properties
- Add support for ArrayProperty
- Add support for second parameter on translate_to_resources
- Extracted apply_properties in provider
- Better row line detection when converting CSV strings
- Pass eeror output from daemon in exception
- Fix rake tasks

## 12-01-2016 Version 1.0.5

- Allow integer validator to accept negative numbers

## 14-11-2015 Version 1.0.4

- Fix typo in IPAddress validator

## 10-11-2015 Version 1.0.3

- Add some more validators

## 04-11-2015 Version 1.0.2

- Better analysing when there are problems in the daemon processes

## 04-11-2015 Version 1.0.1

- better information on entitlements usage.

## 29-06-2015 Version 1.0.0

- Rebranded and changed license
- Added entitlements management

## 24-05-2015 version 0.15.3

- Fix Now on_modify action recognised when deciding if a property needs to be modified

## 20-01-2015  version 0.15.2

- Fix some generator problems

## 09-01-2015  version 0.15.1

- Uppercase and lowe case mungers more resilent to input

## 08-01-2015  version 0.15.0

- Added support for different commands in command builder api

## 14-12-2014  version 0.14.0

- Add method autoload_when_present

## 28-10-2014  version 0.13.3

- Small fixes in the generated templates

## 28-10-2014  version 0.13.2

- Small fixes in the generator
- Small fixes in the command_builder

## 07-10-2014  version 0.13.1

- Added support for using -%> in erb templates.
- Moved to metadata.json

## 01-09-2014  version 0.13.0

- Added support for specifying a second option parameter on a command_builder. This is needed to support the Oracle SID's

## 01-09-2014  version 0.13.0

- Added support for specifying a second option parameter on a command_builder. This is needed to support the Oracle SID's

## 11-07-2014  version 0.12.2

- Fixed a bug that caused OrwWls to fail.

## 10-07-2014  version 0.12.1

- Added support for specifying the daemon timeout on the sync.

## 10-07-2014  version 0.12.0

- Added support for using `on_create` and `on_modify` instead of just a `on_apply` in the properties. This allows for more granularity in the code and less if's.

## 09-07-2014  version 0.11.0

- Added support for scaffolding and generating properties and parameters.

## 25-06-2014  version 0.10.1

- Added support for Integer mungers. Also refactored the munger module to make it easy to add mungers based on standard classes.

## 19-06-2014  version 0.10.0

- Added support for timeouts on the daemon. Also added suport for refresh of the custom type

## 13-06-2014  Version 0.9.0

- Added support for mapping the title to different attributes and parameters

## 02-06-2014  Version 0.8.1.

- Added support for defining your own pass and fail strings in the Daemon's sync.

## 24-05-2014  Version 0.8.0.

- Added support for daemon's for slow external utilities to be used on multiple types.

## 19-02-2014

- Started using the CSV parser class for parsing the CSV's.

## 16-02-2014

- Renamed all to easy_type. It fits the purpose better

## 12-01-2014	Version 0.2.0.

- Added support for having multiple before and after commands in the CommandBuilder.Added support for getting the property_hash and the property_flush. Added support for including parameter and property file pass the commandbuilder in the on_apply function

## 30-12-2013  Inital version

- based on extraction of common code from Oracle types for prorail deployment
