#
# See the file "LICENSE" for the full license governing this code.
#
#++--++
#--++--
define easy_type::secure::ensure_set(
  String[1]                 $set,
  Easy_type::Baseline_type  $benchmark,
  Optional[String[1]]       $product_version,
  Optional[String[1]]       $doc_version,
)
{

  $control_set = lookup("${caller_module_name}::sets::${set}", Array[String[1]], undef, undef)

  if $product_version and $doc_version{
    easy_type::validate_versions($caller_module_name, $benchmark, $product_version, $doc_version)
    $control_map = lookup("${caller_module_name}::control_map", Hash[String[1], String[1]], undef, undef)
    $sanitized_doc_version = regsubst($doc_version,/\./,'_','G').downcase

    echo {"Apply ${caller_module_name} control set ${set} from ${product_version} ${doc_version} on ${title}.": withpath => false,}

    $selected_controls = $control_map.filter |$chapter, $control| {
      $control in $control_set
    }

    notice $selected_controls
    #
    # Now call back to the original module and see if we need to filter out some of the controls
    #
    $current_controls = call("${caller_module_name}::filter_controls", $title, $selected_controls)

    $current_controls.each |String[1] $paragraph_name, String[1] $control_name | {
      $control_class_name = "${caller_module_name}::${product_version}::${sanitized_doc_version}::${set.downcase}::${control_name}::${title.downcase}"
      unless defined($control_class_name) {
        # Generate puppet puppet_code
        $puppet_code = @("PUPPET")
        unless defined(Class[${control_class_name}]) {
          class ${control_class_name} {
            ${caller_module_name}::controls::${control_name} { "${title}": }
          }
        } else {
          debug('Somehow class already defined. Sipping redefinition')
        }
        PUPPET
        easy_type::evaluate_puppet($puppet_code)
        include $control_class_name
      } else {
        debug "class ${control_class_name} somehow olready defined."
      }
    }
  } else {
    warning('skipping because version and/or doc_version is not set or found. Might be running on next run.')
  }
}
